package com.logicbig.example;


import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.UriInfo;
import java.net.URI;

@Path("/users")
public class UserResource {
    @Context
    UriInfo uriInfo;

    public UserResource() {
        printUriInfo("In constructor");
    }

    @GET
    public String getUsers() {
        printUriInfo("In getUsers() method");
        return "returning dummy user list";
    }

    @GET
    @Path("{id}")
    public String getUserById(@PathParam("id") String id) {
        printUriInfo("In getUserById() method");
        return "returning dummy user by id " + id;
    }

    private void printUriInfo(String msg) {
        System.out.println("---------------");
        System.out.println(msg);
        System.out.println("-- UriInfo --");
        if (uriInfo == null) {
            System.out.println("UriInfo: " + uriInfo);
            return;
        }
        System.out.println("absolutePath: " + uriInfo.getAbsolutePath());
        System.out.println("baseUri: " + uriInfo.getBaseUri());
        System.out.println("matchedResource: " + uriInfo.getMatchedResources());
        System.out.println("matchedUri: " + uriInfo.getMatchedURIs());
        System.out.println("path: " + uriInfo.getPath());
        System.out.println("pathParameters: " + uriInfo.getPathParameters());
        System.out.println("pathSegments: " + uriInfo.getPathSegments());
        System.out.println("queryParameters: " + uriInfo.getQueryParameters());
        System.out.println("requestUri: " + uriInfo.getRequestUri());
        System.out.println("relativize test: " + uriInfo.relativize(URI.create("test")));
        System.out.println("resolve test: " + uriInfo.resolve(URI.create("test")));
    }
}